//
//  ViewController.swift
//  CollectionViewSelection
//
//  Created by Mic Pringle on 16/05/2016.
//  Copyright © 2016 Razeware LLC. All rights reserved.
//

import UIKit

class ViewController: UICollectionViewController {
  
  var selectedIndexPath: NSIndexPath? {
    didSet(previousIndexPath) {
      guard let selectedIndexPath = selectedIndexPath else { return }
      if selectedIndexPath == previousIndexPath {
        collectionView!.deselectItemAtIndexPath(selectedIndexPath, animated: true)
        /*
          The delegate method isn't called when programatically (de)selecting a cell, 
          so you need to call it manually
        */
        collectionView(collectionView!, didDeselectItemAtIndexPath: selectedIndexPath)
      }
    }
  }
  
  override func viewDidLoad() {
    super.viewDidLoad()
    
    collectionView!.allowsSelection = true
    collectionView!.allowsMultipleSelection = false
    collectionView!.contentInset = UIEdgeInsets(top: 20, left: 0, bottom: 0, right: 0)
  }
  
  override func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
    return 1
  }
  
  override func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
    return 20
  }
  
  override func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
    let cell = collectionView.dequeueReusableCellWithReuseIdentifier("SelectMe", forIndexPath: indexPath)
    return cell
  }
  
  override func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
    let cell = collectionView.cellForItemAtIndexPath(indexPath)
    cell?.backgroundColor = .redColor()
    selectedIndexPath = indexPath
  }
  
  override func collectionView(collectionView: UICollectionView, didDeselectItemAtIndexPath indexPath: NSIndexPath) {
    let cell = collectionView.cellForItemAtIndexPath(indexPath)
    cell?.backgroundColor = .whiteColor()
    selectedIndexPath = nil
  }
}

